
#pragma once

#include "SADXHeader.h"

#define ADXK0 0x7298
#define ADXK1 0x3350

#define DEFAULT_MASTER_VOLUME 0x4000
#define BLOCKS_PER_ONCE (1 << 7)

#define SIZEOF_ADX_COMMON       (28)
#define SIZEOF_ADX_V3_SPECIFIC  (12)
#define SIZEOF_ADX_V4_SPECIFIC  (24)
#define SIZEOF_ADX_V3           (SIZEOF_ADX_COMMON  + SIZEOF_ADX_V3_SPECIFIC)
#define SIZEOF_ADX_V4           (SIZEOF_ADX_COMMON  + SIZEOF_ADX_V4_SPECIFIC)

class CAuADXDecoder
{
private:
  struct SADXContext
  {
    int s1;
    int s2;
  };

  // kpi ƂĕKvȂ
  HANDLE m_hFile;      // = CreateFile(...)
  SOUNDINFO m_Info;
  SADXHeader m_Header;
  Nokomo::UnitConvs::CAuPcmUnitConverter* m_pPuc;
  Nokomo::SyncObjects::CAuCriticalSection* m_pCs;

  // sxwb_͖̂ʓ|Ȃ̂łɂĂ
  DWORD m_dwSamples;   // Tv
  DWORD m_dwLoopStart; // Tvl
  DWORD m_dwLoopEnd;   // TvlC[vȂƂl͉̂Ŗ
  DWORD m_dwDataOffset;// oCglCf[^JnItZbg
  DWORD m_dwSamplesDecoded;
  int m_nMasterVolume;
  LPSTR m_szIniFile;

  // tB^ŎgO܂ł̃Tvl
  SADXContext m_Context[2]; // ő 2 `l

  // wb_ǂŃ`FbN
  BOOL ReadHeader();
  // Open() Ct@C擪Đł悤
  void Reset();
  // 1w + 32h fR[h
  void DecodeBlock(BYTE* pSource, short* pDest, SADXContext& context);
  // dwSize oCgfR[h
  DWORD DecodeBuffer(BYTE* pBuffer, DWORD dwSize);

public:
  CAuADXDecoder();
  ~CAuADXDecoder();

  BOOL Open(LPSTR szFileName, SOUNDINFO* pInfo);
  void Close();

  DWORD SetPosition(DWORD dwPos);
  DWORD Render(BYTE* pBuffer, DWORD dwSize);
  VOID SeekToLoopStartBlock();

  // accessors
  BOOL GetLoopFlag() const { return m_Info.dwLoopFlag; }
  DWORD GetLoopStart() const { return m_dwLoopStart; }
  DWORD GetLoopEnd() const { return m_dwLoopEnd; }
  DWORD GetCurrentSamplesRendered() const { return m_dwSamplesDecoded; }
  VOID SetConfigPath(LPSTR szPath) { m_szIniFile = szPath; }
};

